#!/usr/bin/env python

import urllib2, codecs
from crawler_package import basic_crawler
from crawler_package.crawling_utils import canonicalize_sitename, simplify_netloc
    
def call_find_links (url,out_file, external_only=False, depth=260):
    def external_link(netloc, pageloc, external_only):
        # print netloc, pageloc, external_only, netloc <> pageloc
        if external_only:
            return (netloc <> pageloc)
        else:
            return True
    #links = basic_crawler.findLinks(url)
    #new_links = [(simplify_netloc(l[0]),l[1]) for l in links]
    #new_links = [(l[0],l[1]) for l in new_links \
    #             if external_link(site_name,l[0],external_only)]
    crawler = basic_crawler.Crawler(url, depth)
    crawler.crawl()
    links = crawler.external
    # print 'external', links
    site_name = canonicalize_sitename(url)
    new_links = []
    urlparser = urllib2.urlparse.urlparse
    for url in links:
        (scheme, netloc, path, params, query, fragment) = urlparser(url)
        netloc = simplify_netloc(netloc)
        if external_link(netloc,site_name,external_only):
            netloc = codecs.utf_8_encode(netloc,'ignore')[0]
            path = codecs.utf_8_encode(path,'ignore')[0]
            print '%s\t%s' % (netloc, path)
            new_links.append((netloc,path))
    res_str = '\n'.join(['%s\t%s' % (x[0],x[1]) for x in new_links])
    console = None
    if out_file:
        console = sys.stdout
        print 'Writing file %s' % out_file
        sys.stdout = open(out_file,'w')
    print res_str
    if console:
        sys.stdout.close()
        sys.stdout = console
    return res_str

if __name__ == "__main__":
    def usage (sysargs):
        print 'Usage: %s [options] <url> [<out_file>]' % sysargs[0]
        print '%-7s%-10s: web page to fetch' % ('','<url>',)
        print '%-7s%-10s: file to print links to in tab-separated format (optional)' % ('','<out_file>',)
        print '%-7s%-10s: Fetch external links only (Boolean). Default=False' % ('','-e option',)
        sys.exit()
        
    import sys
    external_only = False
    if len(sys.argv) < 2:
        usage(sys.argv)
    else:
        sysargs = sys.argv[1:]
    if sysargs[0] == '-e':
        external_only = True
        print 'Recording external links only'
        sysargs = sysargs[1:]
    if sysargs:
        url = sysargs[0]
        sysargs = sysargs[1:]
    else:
        usage(sys.argv)
    if sysargs:
        out_file = sysargs[0]
    else:
        out_file = None
    links = call_find_links(url,out_file,external_only=external_only)
    print links
    
        
